// Geometry2.h: interface for the Geometry class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GEOMETRY2_H__D3A01841_3298_11D5_B299_0000F45E143E__INCLUDED_)
#define AFX_GEOMETRY2_H__D3A01841_3298_11D5_B299_0000F45E143E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class Geometry  
{

public:
	Geometry();
	virtual ~Geometry();

    static void cross( float *v1, float *v2, float *res);
    static float dot( float *v1, float *v2);
    static int isZero(float s);
	static void line_and_plane(float *s, float *lambda, int parallel, 
					float *a, float *ab, float *planeNormal, 
					float *planePoint);
    static int ifIntersect(float *Qi, float *Qii, float *planeNormal, 
		            float *planePoint);
	static float Norm(float *v);
    static void normalize(float *v);
	static float trArea(float *p0, float *p1, float *p2);
	static void trNormal(float *p0, float *p1, float *p2, float *n);
    static inline float det(float *row1, float *row2, float *row3);
    static void MatrByVect(float M[16], float v[4], float res[4]);
    static void vector(float *p1, float *p2, float *v);
	static void trlOrtho(float *p0,  float *p1, float *p2, float *centroid);
	static float dist(float *p1, float *p2);

};

#endif // !defined(AFX_GEOMETRY2_H__D3A01841_3298_11D5_B299_0000F45E143E__INCLUDED_)
