// Loader.cpp: implementation of the Loader class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "soft.h"
#include "Loader.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Loader::Loader()
{

}

Loader::~Loader()
{

}

bool Loader::Load(CString fileName, polyData* modelPtr)
{
	int nPts, nPolys;

    ifstream inFile;
    inFile.open(fileName); 
    if (!inFile) 
	{ 
	 cerr <<"\nCan not open File:"<<inFile; 
     exit(1);
	}
 
  char line[256];
  int num_line = 0;
  int count = 0;
  char *p=NULL; 
  int curPoint=0;

  char pattern1[] = "POINTS";
  char pattern2[] ="POLYGONS";

inFile.getline(line, sizeof(line));
while ( (p=strstr(line, pattern1)) == 0)
{ 
  inFile.getline(line,sizeof(line) );
} 

char text[10]; 
int temp;
  
if ( (p=strstr(line, pattern1)) != NULL)
 {
  sscanf(line, "%s %d %d", &text, &nPts, &temp);
 }  // read the number of points

  modelPtr->SetNumPoints(nPts);
  modelPtr->allocatePoints(nPts);

  while (inFile.getline(line, sizeof(line)))
  { 
  if ((p=strstr(line, pattern2)) != NULL) break;
 
   sscanf(line, "%f %f %f %f %f %f %f %f %f", &modelPtr->Points[curPoint][0],
	                                          &modelPtr->Points[curPoint][1], 
		                                      &modelPtr->Points[curPoint][2],
										      &modelPtr->Points[curPoint+1][0],
										      &modelPtr->Points[curPoint+1][1],
										      &modelPtr->Points[curPoint+1][2],
										      &modelPtr->Points[curPoint+2][0],
											  &modelPtr->Points[curPoint+2][1],
											  &modelPtr->Points[curPoint+2][2]); 
   curPoint +=3; 
   
};  //end of search for "POLYGONS" and reading points data


if ( (p=strstr(line, pattern2)) != NULL)
 {
  sscanf(line, "%s %d %d", &text, &nPolys, &temp);
 }  // read the number of polygons
else nPolys=0;

   modelPtr->SetNumTrs(nPolys);
   modelPtr->allocatePolys(nPolys);

if (nPolys !=0)
{
  int temp;

  int curTr=0;

  while (inFile.getline(line, sizeof(line)))
  { 
    sscanf(line, "%d %d %d %d", &temp, &modelPtr->Triangles[curTr][0],
	      &modelPtr->Triangles[curTr][1], &modelPtr->Triangles [curTr][2]);
   curTr++; 
  }  //end of triangles reading

}
//

inFile.clear();
inFile.close(); //clear stream state and close it

return(true);

}