// featureHandler.h: interface for the featureHandler class.
//
//////////////////////////////////////////////////////////////////////
#include "curvature.h"
#include "Geometry2.h"
#include "LList.h"

#if !defined(AFX_FEATUREHANDLER_H__15505061_F136_11D4_B299_0000F45E136F__INCLUDED_)
#define AFX_FEATUREHANDLER_H__15505061_F136_11D4_B299_0000F45E136F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class featureHandler  
{
public:
    LList ridge;
    LList ravine;

	featureHandler();
	virtual ~featureHandler();

	void getRidge(polyData *model, curvature *C, float threshhold);
    void getRavine(polyData *model, curvature *C, float threshhold);
    void featureConnect(LList *ridgePtr, polyData *modelPtr, LList *ridgeEdges);
    float dKmax_dTmin(curvature *Curv, int ptId, polyData *modelPtr);
    float dKmin_dTmax(curvature *Curv, int ptId, polyData *modelPtr);
    void getNeibhdTrs(LList feature, polyData *model, LList* neibhd);    //get list 
	                                          // of 1st circle Trs ring of a feature

};

#endif // !defined(AFX_FEATUREHANDLER_H__15505061_F136_11D4_B299_0000F45E136F__INCLUDED_)
