// renderer.h: interface for the renderer class.
//
//////////////////////////////////////////////////////////////////////
#include "LList.h"
#include "polyData.h"

void getContour3D(polyData *model, float *view, LList *contour);
void smoothField(float **T, float **smoothed, polyData *model, int iterN);
float getMinEdge(polyData *model);
void sketchRavine(float **field, CSoftDoc *doc, float viewDir[4],
				       float strokeLength, float strokeWidth, float m_featureThr);
void sketchRidge(float **field, polyData *modelPtr, float *viewDir,
				       LList ridge, curvature *curv, float strokeLength, 		
				                         float strokeWidth, float m_featureThr);
BOOL isOnFrontFacing(int ptId, polyData *model, float *view);
BOOL isFrontFacing(int trId, polyData *model, float *view);
void sketchContour(LList *contour, float *view, polyData *modelPtr, 
				          float strokeLength, float strokeWidth);
