#include <stdio.h>



#ifndef _LLIST_H_

#define _LLIST_H_



#include <iostream.h>



//-------------------------- LList



// Declaration of a linked list of Nodes of parametrized type.

// Access to the list is through a pointer, "current", to a node in the list.

// All insertion and deletion is done at the current position.







class LList

{

   

// Declaration of the class of nodes in a linked LList.

// A node contains a value of type int and a pointer to a node.

struct Node {

   inline Node() {   next = NULL;}      // constructor.  We can't initialize value

                                       // to 0, since T may not have zeros.

   

   int        value;               // data stored in a node

   Node      *next;               // pointer to next node

};

  

protected:

   // Note here that first, current, and last are all pointer to _N_,

   // rather than pointer to Node.  This one place where the flexibility comes

   // in later.  If we pointed to Node here, then any class that inherited

   // from LList would then contain pointers to Nodes, even if they "wanted"

   // pointers to some other type (such as DNode).

   Node     *first,               // pointer to first node in the list

            *current,            // pointer to current node

            *last;               // pointer to the last node in the list

   int   size;               // number of elements in the list



public:

   LList();                     // Construct an empty list.

   LList(const LList& l);         // copy constructor

   ~LList();               // destructor

   void Clear();                  // Empty a list, deleting all elements.

   

   LList& operator= (const LList& l);  // assignment overload

   

   void InsertBefore(int e);         // Insert e at current position.

   void InsertAfter(int e);         // Insert e after the current position

   void Remove();               // Delete the node at the current position.

   

   inline void Head()             // Move current position to the head.

       { current = first;};

   inline void Tail()            // Move current position to the tail.

       { current = last;};

   void Forward(void);            // Move current to next position if possible.

   void Back(void);            // Move current to previous position if possible.

   

   int Retrieve() const;            // Return the element at the current position.

   void Update(int e);               // Store e in current location.

   int Includes(int e);               // Test for membership

   

   inline int length() const      // Return the length of the list

       { return size;};

   

};

#endif



